function sfg = ex05_LWDF_9_2;
% EXAMPLE 9.2, p.272 in Digital Filters 2001

wcT = 0.4; wsT = 0.5; Amax = 0.1; Amin = 60;

wac = 2*tan(wcT*pi/2);
was = 2*tan(wsT*pi/2);
N = ellipord(wac, was, Amax, Amin, 's');
[Za, Pa, Ga] = ellipap(N, Amax, Amin);
[Z, P, G] = bilinear(Za*wac, Pa*wac, Ga*wac^(length(Pa) - length(Za)), 1);

coeff = getLWDFcoefficients(P);
sfg = sfg_LWDF(coeff);

N = 2^10;
impres = impulseresponse(sfg, N, 0);
H = 20*log10(abs(fft(impres)));

figure;
wT = linspace(0, 2, N);
subplot(2, 1, 1); plot(wT, H); axis([0 wcT -Amax 0]);
subplot(2, 1, 2); plot(wT, H); axis([0 1 -1.5*Amin 10]);
