function [sfg, sfg_flatten] = ex06_LWDF_15_4;
% EXAMPLE 15.4, p.382 in Digital Filters 2001

coeff = [0.9388445, -0.8839692, 0.9961509, -0.8943932, ...
         0.9908431, -0.9266217, 0.9816495, -0.9742970, 0.9756057];

sfg = sfg_LWDF(coeff);
printcomplexity(sfg);
getTmin(sfg);
plotprecedence(sfg);

sfg_flatten = flattensfg(sfg);
printcomplexity(sfg_flatten);
%getTmin(sfg_flatten); % Slooooow...
plotprecedence(sfg_flatten);

N = 2^12;
impres = impulseresponse(sfg_flatten, N, 0);
H = 20*log10(abs(fft(impres)));

figure;
wT = linspace(0, 2, N);
subplot(2, 1, 1); plot(wT, H); axis([0 0.07 -0.2 0]);
subplot(2, 1, 2); plot(wT, H); axis([0 1 -80 10]);
