function ex07_flatten;

disp('Symmetric twoport adaptor');
sfg = [];
sfg = addoperand(sfg, 'in', [1 1]);
sfg = addoperand(sfg, 'in', [2 2]);
sfg = addoperand(sfg, 'out', [1 3]);
sfg = addoperand(sfg, 'out', [2 4]);
sfg = addoperand(sfg, 'twoport', [1 1 2 3 4 0.7], 'sym');
sfg = flattensfg(sfg);
sfg = printprecedence(sfg);
plotprecedence(sfg, 'Symmetric twoport adaptor');

disp('Series twoport adaptor');
sfg = [];
sfg = addoperand(sfg, 'in', [1 1]);
sfg = addoperand(sfg, 'in', [2 2]);
sfg = addoperand(sfg, 'out', [1 3]);
sfg = addoperand(sfg, 'out', [2 4]);
sfg = addoperand(sfg, 'twoport', [1 1 2 3 4 0.7], 'ser');
sfg = flattensfg(sfg);
sfg = printprecedence(sfg);
plotprecedence(sfg, 'Series twoport adaptor');

disp('Parallel twoport adaptor');
sfg = [];
sfg = addoperand(sfg, 'in', [1 1]);
sfg = addoperand(sfg, 'in', [2 2]);
sfg = addoperand(sfg, 'out', [1 3]);
sfg = addoperand(sfg, 'out', [2 4]);
sfg = addoperand(sfg, 'twoport', [1 1 2 3 4 0.7], 'par');
sfg = flattensfg(sfg);
sfg = printprecedence(sfg);
plotprecedence(sfg, 'Parallel twoport adaptor');

disp('Multiply-accumulate');
sfg = [];
sfg = addoperand(sfg, 'in', [1 1]);
sfg = addoperand(sfg, 'in', [2 2]);
sfg = addoperand(sfg, 'out', [1 3]);
sfg = addoperand(sfg, 'mac', [1 1 2 3 0.7]);
sfg = flattensfg(sfg);
sfg = printprecedence(sfg);
plotprecedence(sfg, 'Multiply-accumulate');

