function sfg = ex08_impulsestep_1_2;
% EXAMPLE 1.2, p.32 (figures at p.31) in Digital Filters 2001

a = 0.252466; b = 0.809096;
P = [0.373304, (a + j*b), (a - j*b)];

coeff = getLWDFcoefficients(P);
sfg = sfg_LWDF(coeff);

N = 500;
impres = impulseresponse(sfg, N, 0);
c = 0.3/impres(1);
figure;
stem(0:50, c*impres(1:51), '.');

s = stepresponse(sfg, N, 0);
figure;
stem(0:50, c*s(1:51), '.');

figure;
Amax = 0.969; Amin = 21.87;
H = 20*log10(abs(fft(impres)));
wT = linspace(0, 2, N);
subplot(2, 1, 1); plot(wT, H); axis([0 1 -Amax 0]);
subplot(2, 1, 2); plot(wT, H); axis([0 1 -1.5*Amin 10]);
