function sfg = ex09_firN24;

% Coefficients from
% 'Designing Multiplier Blocks with Low Logic Depth', 
% A. G. Dempster, S. S. Demirsoy, I. Kale
coeff = [-710, 327, 505, 582, 398, -35, -499, -662, -266, 699, 1943, 2987];
coeff = [coeff, 3395, fliplr(coeff)];
coeff = coeff*8.140000854778397e-005;
%coeff = remez(24, [0 .25 .3 1], [1 1 0 0]);

sfg = sfg_firfilter(coeff);
plotprecedence(sfg, 'FIR filter');
impulseresponse(sfg, 40);

N = 2^12;
impres = impulseresponse(sfg, N, 0);
H = 20*log10(abs(fft(impres)));

figure;
wT = linspace(0, 2, N);
subplot(2, 1, 1); plot(wT, H); axis([0 0.25 -1.3 1.3]);
subplot(2, 1, 2); plot(wT, H); axis([0 1 -30 10]);

