function sfg = ex11_firN27;

% Coefficients
coeff = zeros(1, 14);
coeff(1) = 2284;
coeff(2) = 1824;
coeff(3) = 1092;
coeff(4) = 363;
coeff(5) = -139;
coeff(6) = -334;
coeff(7) = -286;
coeff(8) = -132;
coeff(9) = 6;
coeff(10) = 72;
coeff(11) = 73;
coeff(12) = 45;
coeff(13) = 18;
coeff(14) = 4;
coeff = [fliplr(coeff), coeff];
% Safe scaling
coeff = coeff/sum(abs(coeff));

sfg = sfg_firfilter(coeff);
impulseresponse(sfg, 40);

N = 2^12;
impres = impulseresponse(sfg, N, 0);
H = 20*log10(abs(fft(impres)));

figure;
wT = linspace(0, 2, N);
plot(wT, H); axis([0 1 -100 10]);
