function sfg = ex13_synthesis;
% See Chapter 12 in "VHDL Design Representation and Synthesis" (second edition)

% X = 0.63*(A + B + C)
% Y = (A + C)*0.32

sfg = addoperand([], 'in', [1 1]); % A input
sfg = addoperand(sfg, 'in', [2 2]); % B input
sfg = addoperand(sfg, 'in', [3 3]); % C input
sfg = addoperand(sfg, 'out', [1 6]); % X output
sfg = addoperand(sfg, 'out', [2 8]); % Y output
sfg = addoperand(sfg, 'add', [1 1 2 4]); % A + B
sfg = addoperand(sfg, 'add', [2 4 3 5]); % (A + B) + C
sfg = addoperand(sfg, 'add', [3 1 3 7]); % A + C
sfg = addoperand(sfg, 'mult', [1 5 6 0.63]); % (A + B + C)*0.63
sfg = addoperand(sfg, 'mult', [2 7 8 0.32]); % (A + C)*0.32

plotprecedence(sfg, 'Data flow graph');


% RESULT:
% 
% sfg =
%
%    1.0000    1.0000    1.0000       NaN       NaN
%    1.0000    2.0000    2.0000       NaN       NaN
%    1.0000    3.0000    3.0000       NaN       NaN
%    2.0000    1.0000    6.0000       NaN       NaN
%    2.0000    2.0000    8.0000       NaN       NaN
%    3.0000    1.0000    1.0000    2.0000    4.0000
%    3.0000    2.0000    4.0000    3.0000    5.0000
%    3.0000    3.0000    1.0000    3.0000    7.0000
%    5.0000    1.0000    5.0000    6.0000    0.6300
%    5.0000    2.0000    7.0000    8.0000    0.3200