function [sfg, int_coeff] = ex14_fir_MCM(filter_no);

% Filters from
% 'Maximal Sharing of Partial Terms inMCM under MSD representation'
% Costa, Flores, Monteiro

if ~nargin
   error('Select filter (1 to 12)!');
end

switch filter_no
   case  1, N = 119; wc = 0.20; ws = 0.25; wd =  8; % RAG-n OK!
   case  2, N =  99; wc = 0.10; ws = 0.25; wd = 10; % RAG-n OK!
   case  3, N =  39; wc = 0.15; ws = 0.25; wd = 12; % RAG-n OK!
   case  4, N =  79; wc = 0.20; ws = 0.25; wd = 12; % RAG-n OK!
   case  5, N = 119; wc = 0.24; ws = 0.25; wd = 12; % RAG-n OK!
   case  6, N =  59; wc = 0.15; ws = 0.25; wd = 14;
   case  7, N =  59; wc = 0.15; ws = 0.20; wd = 14;
   case  8, N =  99; wc = 0.15; ws = 0.20; wd = 16;
   case  9, N =  59; wc = 0.10; ws = 0.15; wd = 14;
   case 10, N =  99; wc = 0.10; ws = 0.15; wd = 16;
   case 11, N =  99; wc = 0.10; ws = 0.12; wd = 16;
   case 12, N = 119; wc = 0.10; ws = 0.12; wd = 18;
   otherwise, error('Unknown filter!');
end

coeff = remez(N, [0 wc ws 1], [1 1 0 0]);

int_coeff = get_intcoeffs(coeff, wd);
addpath /home/tde/kennyj/matlab/art/dempster/RAGn/
[addercost, flipflopcost, vertices, optimalflag, graphtable, step_stat, FAcost] = RAGn(int_coeff, 0);
disp('RAG-n');
disp(sprintf('Adders : %d', addercost));
disp(sprintf('Optimal: %d', optimalflag));

sfg = sfg_firfilter(coeff);
plotprecedence(sfg, 'FIR filter');
impulseresponse(sfg, N + 5);

N = 2^8;
impres = impulseresponse(sfg, N, 0);
H = 20*log10(abs(fft(impres)));

figure;
wT = linspace(0, 2, N);
subplot(2, 1, 1); plot(wT, H); axis([0 wc -10 10]);
subplot(2, 1, 2); plot(wT, H); axis([0 1 -300 10]);

